#!/usr/bin/env python3

# Simulate remote server.

# All it does: takes input file as encrypted and tries to decrypt.
# Returns 0 in case of success or 1 in case of invalid padding.

import sys, os
 
def delete_if_exists(fname):
    if os.path.exists(fname):
        os.unlink(fname)

input_fname=sys.argv[1]
pri_fname=sys.argv[2]

tmpfname="tmp2_"+str(os.getpid())
delete_if_exists(tmpfname)
# OpenSSL outputs decrypted file. but we redirect it to /dev/null, for the sake of demonstration.
os.system("openssl rsautl -decrypt -inkey "+pri_fname+" -in "+input_fname+" -out /dev/null -pkcs 2> "+tmpfname)
f=open(tmpfname)
rt="\n".join(f.readlines())
#print (rt)
f.close()
delete_if_exists(tmpfname)
if "padding check failed" in rt:
    exit(1)
else:
    exit(0)

